/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/

package at.jku.ssw.marker;

import at.jku.ssw.ftcm.Activator;
import at.jku.ssw.ftcm.preferences.Feature;
import at.jku.ssw.ftcm.preferences.ProjectSettingsManager;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.text.source.Annotation;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.ui.texteditor.IAnnotationImageProvider;
import org.eclipse.ui.texteditor.SimpleMarkerAnnotation;

public class FeatureImageProvider implements IAnnotationImageProvider {

    @Override
    public Image getManagedImage(Annotation annotation) {

        if (annotation instanceof SimpleMarkerAnnotation) {

            SimpleMarkerAnnotation sma = (SimpleMarkerAnnotation) annotation;

            Image image = new Image(Activator.getShell().getDisplay(), new Rectangle(0, 0, 8, 8));

            GC gc = new GC(image);

            Color c = new Color(Activator.getShell().getDisplay(), 0, 0, 0);
            for (Feature f : ProjectSettingsManager.getInstance(sma.getMarker().getResource().getProject()).getFeatureList()) {
                if (f.getId() == sma.getMarker().getAttribute("feature", 0)) {
                    c = new Color(Activator.getShell().getDisplay(), f.getR(), f.getG(), f.getB());
                }
            }

            gc.setBackground(c);
            gc.fillRoundRectangle(0, 0, 8, 8, 4, 4);
            gc.dispose();

            return image;

        } else {
            return null;
        }

    }

    @Override
    public String getImageDescriptorId(Annotation annotation) {
        return null;
    }

    @Override
    public ImageDescriptor getImageDescriptor(String imageDescritporId) {
        return null;
    }
}
