/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.anttracks.classification;

import at.jku.mevss.anttracks.classification.nodes.GroupingNode;
import at.jku.mevss.anttracks.classification.nodes.ListGroupingNode;
import at.jku.mevss.anttracks.classification.nodes.MapGroupingNode;

public abstract class Transformer extends Classifier<GroupingNode> {
    //

    //    @Override
    //    public String toString() {
    //        return getName() != null ? (getName() + "[" + getClassifiers().toString() + "]") : super.toString();
    //    }

    protected GroupingNode classify() throws Exception {
        return classify(baseGrouping());
    }

    protected abstract GroupingNode classify(GroupingNode base) throws Exception;

    public abstract String title();

    public GroupingNode baseGrouping() {
        GroupingNode base = null;

        try {
            switch (Classifier.CLASSIFICATION_MODE) {
                case MAP:
                    base = new MapGroupingNode(null, 0, 0, null, title());
                    break;

                case LIST:
                    base = new ListGroupingNode(null, 0, 0, null, title(), fastHeap());
                    break;

                /*
                case FILE:
                    base = new FileGroupingNode(null, 0, 0, null, title());
                    break;
                    */
            }
        } catch (Exception e) {
            assert false : "Base grouping may not throw exception";
        }
        base.setClassifier(this);
        return base;
    }
}
