/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.anttracks.classification.nodes;

import at.jku.mevss.anttracks.util.Counter;
import at.jku.mevss.anttracks.util.DoubleCounter;

public class GroupingCounter {
    public final Counter exact;
    public final DoubleCounter sampled;

    public GroupingCounter(long exactInit, double sampledInit, boolean allowNegative) {
        exact = new Counter(exactInit, allowNegative);
        sampled = new DoubleCounter(sampledInit, allowNegative);
    }

    public void add(GroupingCounter other) {
        exact.add(other.exact);
        sampled.add(other.sampled);
    }

    public double get() {
        return exact.get() + sampled.get();
    }

    @Override
    public String toString() {
        return (exact.get() + sampled.get()) + " (Exact: " + exact.get() + ", Sampled: " + sampled.get() + ")";
    }

}
