/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.anttracks.compiler;

import javax.tools.*;
import javax.tools.JavaFileObject.Kind;
import java.io.IOException;

public class OnTheFlyCompilationFileManager extends ForwardingJavaFileManager<JavaFileManager> {

    OnTheFlyCompilationClassLoader cl = new OnTheFlyCompilationClassLoader(ClassLoader.getSystemClassLoader());

    protected OnTheFlyCompilationFileManager() {
        super(ToolProvider.getSystemJavaCompiler().getStandardFileManager(null, null, null));
    }

    @Override
    public JavaFileObject getJavaFileForOutput(Location location, String className, Kind kind, FileObject sibling) throws IOException {
        return cl.getByteCodeStub(className);
    }

    @Override
    public ClassLoader getClassLoader(Location location) {
        return cl;
    }
}
