/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.anttracks.features.io;

public class FeaturesToken {

    public static enum Kind {
        IDENTIFIER,
        NUMBER,
        LBRACE,
        RBRACE,
        LPARANTESIS,
        RPARANTESIS,
        LBRACKET,
        RBRACKET,
        DOUBLE_COLON,
        STAR,
        EOF
    }

    public final Kind kind;
    public final String value;
    public final int row, col;

    public FeaturesToken(Kind kind, String value, int row, int col) {
        this.kind = kind;
        this.value = value;
        this.row = row;
        this.col = col;
    }

    public String toString() {
        return kind + " \"" + value + "\" @ (" + row + "," + col + ")";
    }

}
