package at.jku.mevss.anttracks.heap;

import at.jku.mevss.anttracks.heap.objects.ObjectInfo;
import at.jku.mevss.anttracks.util.TraceException;

public interface ObjectAccess {
    static long PTR_ADJUSTMENT_NEEDED_MASK = 0x1l;
    static long PTR_ADJUSTMENT_NEEDED_RESET_MASK = 0xFFFFFFFFFFFFFFFEl;

    public abstract void setObjectPointers(long objAddr, long[] ptrs) throws TraceException;

    public abstract void setObjectForwardingAddr(long objAddr, long forwAddr) throws TraceException;

    public abstract void setObjectForwardingAddrAndPtrs(long objAddr, long forwAddr, long[] ptrs) throws TraceException;

    public abstract void setFromPointerCount(long objAddr, int n) throws TraceException;

    public abstract ObjectInfo getObject(long objAddr) throws TraceException;

    public abstract long[] getObjectPointers(long objAddr) throws TraceException;

    public abstract long[] getObjectFromPointers(long objAddr) throws TraceException;

    public abstract long getObjectForwardingAddressUnescaped(long objAddr) throws TraceException;

    public abstract long getObjectForwardingAddressEscaped(long objAddr) throws TraceException;

    public abstract void mark(long objAddr) throws TraceException;

    public abstract boolean isMarked(long objAddr) throws TraceException;

    public abstract void setFromPointers(long objAddr, long[] fromPtrs) throws TraceException;

    public abstract boolean ptrNeedAdjustment(long objAddr) throws TraceException;

    public abstract void setPtrNeedAdjustment(long objAddr, boolean needAdjustment) throws TraceException;
}
