/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.anttracks.heap;

import at.jku.mevss.anttracks.heap.objects.ObjectInfo;
import at.jku.mevss.anttracks.heap.roots.RootPtr;
import at.jku.mevss.anttracks.heap.space.SpaceInfo;
import at.jku.mevss.anttracks.heap.symbols.AllocatedType;
import at.jku.mevss.anttracks.heap.symbols.AllocationSite;
import at.jku.mevss.anttracks.parser.EventType;

import java.util.List;

public interface ObjectVisitor {
    class Settings {
        public static Settings ALL_INFOS = new Settings(true, true, true);
        public static Settings NO_INFOS = new Settings(false, false, false);

        public final boolean arrayInfoNeeded;
        public final boolean pointerInfoNeeded;
        public final boolean rootPointerInfoNeeded;

        public Settings(boolean arrayInfoNeeded, boolean pointerInfoNeeded, boolean rootPointerInfoNeeded) {
            this.arrayInfoNeeded = arrayInfoNeeded;
            this.pointerInfoNeeded = pointerInfoNeeded;
            this.rootPointerInfoNeeded = rootPointerInfoNeeded;
        }
    }

    public abstract void visit(long address,
                               ObjectInfo objectInfo,
                               SpaceInfo space,
                               AllocatedType type,
                               int size,
                               boolean isArray,
                               int arrayLength,
                               AllocationSite allocationSite,
                               long[] pointedFrom,
                               long[] pointsTo,
                               EventType eventType,
                               List<RootPtr> rootPtrs);
}
