/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.anttracks.heap;

import at.jku.mevss.anttracks.parser.EventType;

public class StatisticGCInfo {
    public final GarbageCollectionType type;
    public final GarbageCollectionCause cause;
    public final boolean concurrent, failed;
    public final EventType meta;
    public final long time;

    public StatisticGCInfo(GarbageCollectionType type, GarbageCollectionCause cause, boolean concurrent, boolean failed, EventType meta, long time) {
        assert (meta == EventType.GC_START || meta == EventType.GC_END);
        this.type = type;
        this.cause = cause;
        this.concurrent = concurrent;
        this.failed = failed;
        this.meta = meta;
        this.time = time;
    }

    public boolean matches(GarbageCollectionLookup gcLookup) {
        return (gcLookup.cause == null || gcLookup.cause.equals(cause)) &&
                (gcLookup.event == null || gcLookup.event.equals(meta)) &&
                (gcLookup.type == null || gcLookup.type.equals(type));
    }
}
