/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.anttracks.heap.io;

import at.jku.mevss.anttracks.heap.GarbageCollectionCause;
import at.jku.mevss.anttracks.heap.GarbageCollectionLookup;
import at.jku.mevss.anttracks.heap.GarbageCollectionType;
import at.jku.mevss.anttracks.parser.EventType;

public class HeapIndexEntry {
    public final long position;
    public final GarbageCollectionType gcType;
    public final EventType gcMeta;
    public final long time;
    public final int fileName;
    public final boolean heapDumpFileExists;
    public final GarbageCollectionCause gcCause;

    public HeapIndexEntry(long position, GarbageCollectionType gcType, EventType gcMeta, GarbageCollectionCause gcCause, long time, int gcCount, boolean fileExists) {
        super();
        this.position = position;
        this.gcType = gcType;
        this.gcMeta = gcMeta;
        this.gcCause = gcCause;
        this.time = time;
        fileName = gcCount;
        heapDumpFileExists = fileExists;
    }

    public boolean matches(GarbageCollectionLookup gcLookup) {
        if (gcLookup.event != null && !gcMeta.equals(gcLookup.event)) {
            return false;
        }
        if (gcLookup.cause != null && !gcCause.equals(gcLookup.cause)) {
            return false;
        }
        if (gcLookup.type != null && !gcType.equals(gcLookup.type)) {
            return false;
        }
        return true;
    }
}
