/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.anttracks.heap.io;

public class MetaDataWriterConfig extends MetaDataConfig {

    public static int DEFAULT_DUMP_COUNT = 20;
    public static boolean DEFAULT_AT_MAJOR_GCS_ONLY = false;

    public final int dumps;
    public final boolean atMajorGCsOnly;

    public MetaDataWriterConfig(String path) {
        this(path, DEFAULT_DUMP_COUNT, DEFAULT_AT_MAJOR_GCS_ONLY);
    }

    public MetaDataWriterConfig(String path, int dumps, boolean atMajorGCsOnly) {
        super(path);
        this.dumps = dumps;
        this.atMajorGCsOnly = atMajorGCsOnly;
    }

}
