/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.anttracks.heap.statistics;

public class Allocators {
    private long vm;
    private long ir;
    private long c1;
    private long c2;

    public Allocators(long vm, long ir, long c1, long c2) {
        this.vm = vm;
        this.ir = ir;
        this.c1 = c1;
        this.c2 = c2;
    }

    public Allocators() {}

    public long getVm() {
        return vm;
    }

    public void incrementVm() {
        this.vm++;
    }

    public long getIr() {
        return ir;
    }

    public void incrementIr() {
        this.ir++;
    }

    public long getC1() {
        return c1;
    }

    public void incrementC1() {
        this.c1++;
    }

    public long getC2() {
        return c2;
    }

    public void incrementC2() {
        this.c2++;
    }

    public void addC1(long c1) {
        this.c1 += c1;
    }

    public void addC2(long c2) {
        this.c2 += c2;

    }

    public void addIr(long ir) {
        this.ir += ir;
    }

    public void addVm(long vm) {
        this.vm += vm;
    }

    public void clear() {
        this.vm = 0;
        this.ir = 0;
        this.c1 = 0;
        this.c2 = 0;
    }
}
