/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.anttracks.heap.statistics;

public class ObjectTypes {
    private long instances;
    private long smallArrays;
    private long bigArrays;

    public ObjectTypes(long instances, long smallArrays, long bigArrays) {
        this.instances = instances;
        this.smallArrays = smallArrays;
        this.bigArrays = bigArrays;
    }

    public ObjectTypes() {

    }

    public long getInstances() {
        return instances;
    }

    public void incrementInstances() {
        this.instances++;
    }

    public long getSmallArrays() {
        return smallArrays;
    }

    public void incrementSmallArrays() {
        this.smallArrays++;
    }

    public long getBigArrays() {
        return bigArrays;
    }

    public void incrementBigArrays() {
        this.bigArrays++;
    }

    public void addInstances(long instances) {
        this.instances += instances;
    }

    public void addSmallArrays(long size) {
        this.smallArrays += size;
    }

    public void addBigArrays(long size) {
        this.bigArrays += size;
    }

    public void clear() {
        this.instances = 0;
        this.smallArrays = 0;
        this.bigArrays = 0;
    }
}
