/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.anttracks.parser;

import java.nio.ByteBuffer;

public class QueueEntry {

    public static final QueueEntry NULL = new QueueEntry(null, null, 0, false, SyncLevel.NONE);

    public final String thread;
    public final ByteBuffer buffer;
    public final long position;
    public final boolean isCompressed;
    public final SyncLevel sync;

    public QueueEntry(String thread, ByteBuffer buffer, long position, boolean isCompressed, SyncLevel sync) {
        this.thread = thread;
        this.buffer = buffer;
        this.position = position;
        this.isCompressed = isCompressed;
        this.sync = sync;
    }

}
