/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.anttracks.parser;

import at.jku.mevss.anttracks.parser.io.FileInfo;

import java.io.IOException;

public class TraceFileInfo extends FileInfo {

    private final int epoch;

    public TraceFileInfo(FileInfo info, int epoch) throws IOException {
        super(info.getHeader(), info.getFileType());
        if (info.getFileType() != TraceFile.TRACE_FILE_ID) {
            throw new IOException("Illegal file type (expected trace file)");
        }
        this.epoch = epoch;
    }

    public int getEpoch() {
        return epoch;
    }

}
