/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.anttracks.parser.heap.pointer;

import at.jku.mevss.anttracks.heap.DetailedHeap;
import at.jku.mevss.anttracks.heap.labs.Lab;
import at.jku.mevss.anttracks.heap.space.Space;
import at.jku.mevss.anttracks.util.TraceException;

public class PtrUpdateVisitor {
    public final boolean front;
    public final DetailedHeap heap;
    private final boolean gcFailed;

    public PtrUpdateVisitor(boolean front, DetailedHeap heap, boolean failed) {
        this.front = front;
        this.heap = heap;
        this.gcFailed = failed;
    }

    public void visit(Space space, Lab lab, long address, long[] pointsTo) {
        try {
            if (gcFailed) {
                PointerHandling.updateRefsFailedGC(heap, space, lab, address, pointsTo);
            } else {
                PointerHandling.updateRefsNew(heap, space, lab, address, pointsTo);
            }
        } catch (TraceException e) {
            e.printStackTrace();
        }
    }
}
