/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.anttracks.parser.io;

public class FileInfo {

    private final int[] header;
    private final int fileType;

    protected FileInfo(int[] header, int fileType) {
        this.header = header;
        this.fileType = fileType;
    }

    public int[] getHeader() {
        return header.clone();
    }

    public int getFileType() {
        return fileType;
    }

    public boolean matches(FileInfo that) {
        if (that == null) {
            return false;
        } else if (this == that) {
            return true;
        } else if (this.header.length == that.header.length) {
            for (int i = 0; i < header.length; i++) {
                if (this.header[i] != that.header[i]) {
                    return false;
                }
            }
            return true;
        } else {
            return false;
        }
    }

}
