package at.jku.mevss.anttracks.parser.printing;

import at.jku.mevss.anttracks.heap.io.HeapIndexReader;
import at.jku.mevss.anttracks.heap.io.HeapPosition;
import at.jku.mevss.anttracks.heap.symbols.Symbols;
import at.jku.mevss.anttracks.parser.*;
import at.jku.mevss.anttracks.util.MutableLong;
import at.jku.mevss.anttracks.util.TraceException;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.BlockingQueue;

public class PrintingTraceParser extends TraceParser<Void> {
    public PrintingTraceParser(Symbols symbols) throws Exception {
        super(symbols, null);
    }

    @Override
    protected void doWorkspaceCompletion(Void workspace) throws TraceException {

    }

    @Override
    protected void doRemoveListenersOnCompletion(Void workspace) {

    }

    @Override
    protected Void generateWorkspaceFromMetaData(HeapIndexReader heapIndexReader, HeapPosition heapPosition) throws FileNotFoundException, IOException {
        return null;
    }

    @Override
    protected Void generatePlainWorkspace(TraceScannerFactory factory) throws IOException {
        return null;
    }

    @Override
    protected void doParseCleanupAfterSuccessfulParse(Void workspace) throws TraceException {

    }

    @Override
    protected TraceParsingEventHandler createMainEventHandler(ParsingInfo parsingInfo) {
        return null;
    }

    @Override
    protected List<TraceSlaveParser<Void>> startSlaveThreads(MutableLong queueSize,
                                                             BlockingQueue<ThreadLocalHeap> masterQueue,
                                                             Void workspace,
                                                             ErrorHandler handler,
                                                             boolean check,
                                                             ParsingInfo parsingInfo) throws IOException {
        RelAddrFactory relAddrFactory = new RelAddrFactory(symbols.heapWordSize);

        int slaves = 1;
        /*
        if (MULTITHREADING) {
            slaves = Consts.AVAILABLE_PROCESSORS();
        }
        */

        List<TraceSlaveParser<Void>> result = new ArrayList<>();
        for (int i = 0; i < slaves; i++) {
            PrintingTraceSlaveParser parserThread = new PrintingTraceSlaveParser(i, queueSize, masterQueue, workspace, relAddrFactory, symbols, check, handler);
            result.add(parserThread);
        }
        return result;
    }
}
