/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.anttracks.util;

import java.util.Arrays;

public class IntBooleanMap {

    private final long[] data;
    private final int min;

    public IntBooleanMap(int min, int max, boolean initial) {
        this.data = new long[(max - min) / (8 * 8) + 1];
        this.min = min;
        Arrays.fill(data, initial ? (~0) : (0));
    }

    public boolean get(int key) {
        key = key - min;
        int index = key / (8 * 8);
        int shift = key % (8 * 8);
        return ((data[index] >> shift) & 1) != 0;
    }

    public boolean set(int key, boolean value) {
        key = key - min;
        int index = key / (8 * 8);
        int shift = key % (8 * 8);
        data[index] = value ? (data[index] | (1 << shift)) : (data[index] & ~(1 << shift));
        return value;
    }

}
