package at.jku.mevss.anttracks.heap.datastructures

class MovingObject(val startAddress: Long) {
    var inCollectedSpace: Boolean = false
        private set
    var hasBeenMoved: Boolean = false
        private set
    var currentAddress: Long = startAddress
        private set

    //override def compare(that: DS): Int = (this.currentAddress - that.currentAddress).toInt
    fun markInCollectedSpace() {
        inCollectedSpace = true
    }

    fun move(to: Long) {
        assert(inCollectedSpace, { "We should not move objects that do not have to be moved" })
        currentAddress = to
        hasBeenMoved = true
    }

    fun clearMoveInfo() {
        inCollectedSpace = false
        hasBeenMoved = false
    }

    fun stopTracking() {
        hasBeenMoved = false
        inCollectedSpace = false
        currentAddress = -1
    }

    fun died(): Boolean = inCollectedSpace && !hasBeenMoved
}