package at.jku.mevss.anttracks.util.test;

import at.jku.mevss.anttracks.util.IterationUtil;
import org.junit.Assert;
import org.junit.Test;

import java.util.ArrayList;
import java.util.List;

public class IterationUtilTest {
    @Test
    public void testIteration1() {
        List<String> names = new ArrayList<String>();
        names.add("Markus");
        names.add("Tester");

        List<String> results = new ArrayList<>();
        IterationUtil.iterate(names, (name) -> results.add(name));

        Assert.assertEquals(2, results.size());
        Assert.assertTrue(results.contains("Markus"));
        Assert.assertTrue(results.contains("Tester"));
    }

    @Test
    public void testIteration2() {
        List<String> names = new ArrayList<String>();
        names.add("Markus");
        names.add("Tester");

        List<Integer> numbers = new ArrayList<>();
        numbers.add(1);
        numbers.add(2);
        numbers.add(3);

        List<String> results = new ArrayList<>();
        IterationUtil.iterate(names, numbers, (name, number) -> results.add(name + number));

        Assert.assertEquals(6, results.size());
        Assert.assertTrue(results.contains("Markus1"));
        Assert.assertTrue(results.contains("Markus2"));
        Assert.assertTrue(results.contains("Markus3"));
        Assert.assertTrue(results.contains("Tester1"));
        Assert.assertTrue(results.contains("Tester2"));
        Assert.assertTrue(results.contains("Tester3"));
    }

    @Test
    public void testIteration3() {
        List<String> names = new ArrayList<String>();
        names.add("Markus");
        names.add("Tester");

        List<Integer> numbers1 = new ArrayList<>();
        numbers1.add(1);
        numbers1.add(2);
        numbers1.add(3);

        List<Integer> numbers2 = new ArrayList<>();
        numbers2.add(1);
        numbers2.add(2);

        List<String> results = new ArrayList<>();
        IterationUtil.iterate(names, numbers1, numbers2, (name, number1, number2) -> results.add(name + "_" + number1 + "_" + number2));

        Assert.assertEquals(12, results.size());
        Assert.assertTrue(results.contains("Markus_1_1"));
        Assert.assertTrue(results.contains("Markus_1_2"));
        Assert.assertTrue(results.contains("Markus_2_1"));
        Assert.assertTrue(results.contains("Markus_2_2"));
        Assert.assertTrue(results.contains("Markus_3_1"));
        Assert.assertTrue(results.contains("Markus_3_2"));
        Assert.assertTrue(results.contains("Tester_1_1"));
        Assert.assertTrue(results.contains("Tester_1_2"));
        Assert.assertTrue(results.contains("Tester_2_1"));
        Assert.assertTrue(results.contains("Tester_2_2"));
        Assert.assertTrue(results.contains("Tester_3_1"));
        Assert.assertTrue(results.contains("Tester_3_2"));
    }
}
