/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.scala.trace.parser.heap.diff

class DiffGrouping(val perm: Option[Grouping], val born: Option[Grouping], val died: Option[Grouping], val temp: Option[Grouping], val key: Any, val level: Int) {

    def this(perm: Option[Grouping], born: Option[Grouping], died: Option[Grouping], temp: Option[Grouping]) {
        this(perm, born, died, temp, "Overall", 0);
    }

    def getChildren(): List[DiffGrouping] = {
        val children = (g: Option[Grouping]) => g.map(_.getChildren.map(_.keys)).toList
        (children(perm) ++ children(born) ++ children(died) ++ children(temp))
            .distinct
            .map(key => new DiffGrouping(perm.map(_ -> key).flatten, born.map(_ -> key).flatten, died.map(_ -> key).flatten, temp.map(_ -> key).flatten, key, level + 1))
    }

    override def toString(): String = {
        new StringBuilder()
            .append("Perm:\n")
            .append(perm.getOrElse("No perm"))
            .append("\nBorn:\n")
            .append(born.getOrElse("No born"))
            .append("\nDied:\n")
            .append(died.getOrElse("No died"))
            .append("\nTemp:\n")
            .append(temp.getOrElse("No temp"))
            .toString
    }
}