/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.trace.parser.playground

object Worksheet {
    val oi = new TestObjectInfo(EventType.OBJ_ALLOC_SLOW, 1, 1, 8, 8)
    val g = Grouping()

    println(g)

    val classifiers = Seq(new MultiClassification[String] {
        val name = "Splitter"

        def classify(address: Long, pointsTo: Iterable[Long], obj: ObjectInfo) = Set("Author1", "Author2")
    },
        new SingleClassification[Boolean] {
            override def classify(address: Long, pointsTo: Iterable[Long], obj: ObjectInfo): Boolean = address <= 100

            override val name: String = "Address LTE 100"
        },
        new HierarchyClassification[String] {
            val name = "Hierarchy"

            def classify(address: Long, pointsTo: Iterable[Long], obj: ObjectInfo) = List("Allocation", "Caller")
        })
    for (i <- 1 to 10000) {
        g(i, null, oi, classifiers, 1)
    }
    println(g)
}