/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.trace.gui.chart.fxchart.xy.linepane.base;

import at.jku.mevss.trace.gui.chart.base.ChartSynchronizer;
import at.jku.mevss.trace.gui.chart.fxchart.xy.base.XYBaseJavaFXChartPane;
import at.jku.mevss.trace.gui.utils.FXMLUtil;
import javafx.collections.ObservableList;
import javafx.scene.chart.XYChart;

public abstract class LineJavaFXChartPane<DATA> extends XYBaseJavaFXChartPane<DATA> {

    public LineJavaFXChartPane() {
        FXMLUtil.load(this, LineJavaFXChartPane.class);
    }

    @Override
    public void init(ChartSynchronizer chartSynchronizer) {
        super.init(chartSynchronizer);
    }

    @Override
    public double getMaxYValue(ObservableList<XYChart.Series<Number, Number>> seriesList) {
        double maxYValue = Double.MIN_VALUE;

        for (XYChart.Series<Number, Number> series : seriesList) {
            for (XYChart.Data<Number, Number> dataPoint : series.getData()) {
                if (dataPoint.getYValue().doubleValue() > maxYValue) {
                    maxYValue = dataPoint.getYValue().doubleValue();
                }
            }
        }
        return maxYValue;
    }

    @Override
    public double getMinYValue(ObservableList<XYChart.Series<Number, Number>> seriesList) {
        double minYValue = Double.MAX_VALUE;

        for (XYChart.Series<Number, Number> series : seriesList) {
            for (XYChart.Data<Number, Number> dataPoint : series.getData()) {
                if (dataPoint.getYValue().doubleValue() < minYValue) {
                    minYValue = dataPoint.getYValue().doubleValue();
                }
            }
        }
        return minYValue;
    }
}
