/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.trace.gui.classification.classifier.component.selectedconditionalpane;

import at.jku.mevss.trace.gui.model.SelectedClassifierInfo;
import at.jku.mevss.trace.gui.utils.FXMLUtil;
import javafx.fxml.FXML;
import javafx.scene.control.TextArea;
import javafx.scene.layout.BorderPane;

public class SelectedConditionalObjectClassifierPane extends BorderPane {

    // Data
    private SelectedClassifierInfo selectedClassifierInfo;

    private static final String NO_COND_CLASSIFIER_SELECTED_TEXT = "No conditional classifiers";

    // Controls
    @FXML
    private TextArea textArea;

    public SelectedConditionalObjectClassifierPane() {
        FXMLUtil.load(this, SelectedConditionalObjectClassifierPane.class);
    }

    public void init(SelectedClassifierInfo selectedClassifierInfo) {
        this.selectedClassifierInfo = selectedClassifierInfo;
        textArea.setBlendMode(null);
        textArea.setOnMouseClicked(null);
        update();
    }

    public void update() {
        textArea.setText("");
        StringBuilder sb = new StringBuilder();
        if (selectedClassifierInfo.getSelectedConditionalClassifier().size() > 0) {
            for (int i = 0; i < selectedClassifierInfo.getSelectedConditionalClassifier().size(); i++) {
                sb.append(i + 1);
                sb.append(": ");
                sb.append(selectedClassifierInfo.getSelectedConditionalClassifier().get(i));
                sb.append("\n");
            }
        } else {
            sb.append(NO_COND_CLASSIFIER_SELECTED_TEXT);
        }
        textArea.setText(sb.toString());
        // Min height = 1 row
        textArea.setPrefRowCount(Math.max(1, selectedClassifierInfo.getSelectedConditionalClassifier().size()));
    }

    public void setVisibleIfContainsContent() {
        setVisible(!textArea.getText().equals(NO_COND_CLASSIFIER_SELECTED_TEXT));
    }

    public void setManagedIfContainsContent() {
        setManaged(!textArea.getText().equals(NO_COND_CLASSIFIER_SELECTED_TEXT));
    }
}
