/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.trace.gui.classification.classifier.dialog.create;

import at.jku.mevss.anttracks.classification.ClassifierFactory;
import at.jku.mevss.anttracks.classification.ClassifierFactoryList;
import at.jku.mevss.anttracks.heap.IndexBasedHeap;
import at.jku.mevss.anttracks.heap.symbols.Symbols;
import javafx.scene.control.Dialog;

import java.io.IOException;
import java.util.function.Supplier;

public class CreateClassifierDialog extends Dialog<ClassifierFactory> {

    private final CreateClassifierDialogPane dialogPane;

    public CreateClassifierDialog(Supplier<Symbols> symbolsSupplier, Supplier<IndexBasedHeap> fastHeapSupplier, ClassifierFactoryList availableClassifier)
            throws IOException {
        dialogPane = new CreateClassifierDialogPane();
        dialogPane.initialize(symbolsSupplier, fastHeapSupplier, availableClassifier);
        setDialogPane(dialogPane);
        setResizable(true);
        setResultConverter(result -> {
            if (result == dialogPane.createButton) {
                return dialogPane.getNewClassifier();
            }
            // Cancel has been pressed
            return null;
        });
    }
}
