package at.jku.mevss.trace.gui.component.treetableview.cell.memorycell;

import at.jku.mevss.trace.gui.component.treetableview.cell.AntCell;
import at.jku.mevss.trace.gui.component.treetableview.cell.AntCellContent;
import at.jku.mevss.trace.gui.utils.FXMLUtil;
import javafx.fxml.FXML;
import javafx.scene.control.Label;
import javafx.scene.control.Tooltip;

import java.text.DecimalFormat;

public class MemoryCellContent extends AntCellContent<Number> {

    @FXML
    Label label;

    DecimalFormat numberFormat = new DecimalFormat("###,###.#");

    public MemoryCellContent() {
        FXMLUtil.load(this, MemoryCellContent.class);
    }

    @Override
    public void init() {

    }

    @Override
    public void set(AntCell<?, Number, ?> parentCell, Number item) {
        double absVal = Math.abs(item.doubleValue());

        if (absVal >= 1_000_000_000) {
            label.setText(numberFormat.format(item.doubleValue() / 1_000_000_000) + " GB");

        } else if (absVal >= 1_000_000) {
            label.setText(numberFormat.format(item.doubleValue() / 1_000_000) + " MB");

        } else if (absVal >= 1_000) {
            label.setText(numberFormat.format(item.doubleValue() / 1_000) + " kB");

        } else {
            label.setText(numberFormat.format(item.doubleValue()) + " B");
        }
    }

    @Override
    public Tooltip getTooltip(AntCell<?, Number, ?> parentCell, Number item) {
        return new Tooltip(numberFormat.format(item.doubleValue()) + " B");
    }
}
