package at.jku.mevss.trace.gui.component.treetableview.cell.numbercell;

import at.jku.mevss.trace.gui.component.treetableview.cell.AntCell;
import at.jku.mevss.trace.gui.component.treetableview.cell.AntCellContent;
import at.jku.mevss.trace.gui.utils.FXMLUtil;
import javafx.fxml.FXML;
import javafx.scene.control.Label;
import javafx.scene.control.Tooltip;

import java.text.DecimalFormat;

public class NumberCellContent extends AntCellContent<Number> {

    @FXML
    Label label;

    DecimalFormat numberFormat = new DecimalFormat("###,###.#");

    public NumberCellContent() {
        FXMLUtil.load(this, NumberCellContent.class);
    }

    @Override
    public void init() {

    }

    @Override
    public void set(AntCell<?, Number, ?> parentCell, Number item) {
        final double result = item.doubleValue();
        final String text = numberFormat.format(result);
        label.setText(text);
    }

    @Override
    public Tooltip getTooltip(AntCell<?, Number, ?> parentCell, Number item) {
        return null;
    }
}
