package at.jku.mevss.trace.gui.component.treetableview.cell.percentagecell;

import at.jku.mevss.trace.gui.component.treetableview.cell.AntCell;
import at.jku.mevss.trace.gui.component.treetableview.cell.barcell.BarCellContent;
import at.jku.mevss.trace.gui.model.Percentage;
import at.jku.mevss.trace.gui.utils.FXMLUtil;
import javafx.scene.control.Tooltip;

import java.text.DecimalFormat;

public class PercentageCellContent extends BarCellContent<Percentage> {

    private static final DecimalFormat format = new DecimalFormat("###,##0.0");

    public PercentageCellContent() {
        FXMLUtil.load(this, PercentageCellContent.class);
    }

    @Override
    protected String defineTextToShow(Percentage item) {
        return format.format(item.value);
    }

    @Override
    protected double defineFillRatio(Percentage item) {
        return item.value / 100.0;
    }

    @Override
    public Tooltip getTooltip(AntCell<?, Percentage, ?> parentCell, Percentage item) {
        return null;
    }
}
