/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.trace.gui.dialog.about;

import at.jku.mevss.trace.gui.frame.main.GUI;
import at.jku.mevss.trace.gui.utils.Consts;
import at.jku.mevss.trace.gui.utils.FXMLUtil;
import javafx.embed.swing.SwingFXUtils;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.DialogPane;
import javafx.scene.control.Hyperlink;
import javafx.scene.image.ImageView;
import javafx.scene.text.TextFlow;

import java.net.URL;
import java.util.ResourceBundle;

final class AboutDialogPane extends DialogPane implements Initializable {

    @FXML
    private ImageView imageView;
    @FXML
    private TextFlow textFlow;

    @FXML
    Hyperlink downloadLink;

    AboutDialogPane() {
        FXMLUtil.load(this, AboutDialogPane.class);
    }

    @Override
    public void initialize(URL location, ResourceBundle resources) {
        imageView.setImage(SwingFXUtils.toFXImage(Consts.ANT_IMAGE, null));
        setPrefWidth(imageView.getImage().getWidth() + 175);

        downloadLink.setOnAction(new EventHandler<ActionEvent>() {

            @Override
            public void handle(ActionEvent t) {
                GUI.CLIENT_INFO.application.getHostServices().showDocument(downloadLink.getText());
            }
        });
    }

}
