/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.trace.gui.frame.main.component.headertext;

import at.jku.mevss.trace.gui.utils.FXMLUtil;
import at.jku.mevss.trace.gui.utils.HeaderTextSupport;
import javafx.beans.DefaultProperty;
import javafx.beans.property.SimpleStringProperty;
import javafx.beans.property.StringProperty;
import javafx.collections.ObservableList;
import javafx.fxml.FXML;
import javafx.scene.Node;
import javafx.scene.control.Tab;
import javafx.scene.layout.VBox;

@DefaultProperty("extension")
public class HeaderTextTab extends Tab implements HeaderTextSupport {

    private final StringProperty headerTextProperty = new SimpleStringProperty();

    private @FXML
    VBox extension;

    public HeaderTextTab() {
        FXMLUtil.load(this, HeaderTextTab.class);
    }

    public ObservableList<Node> getExtension() {
        return extension.getChildren();
    }

    public void setHeaderText(String headerText) {
        headerTextProperty.set(headerText);
    }

    @Override
    public String getHeaderText() {
        return headerTextProperty.get();
    }

    public StringProperty getheaderTextProperty() {
        return headerTextProperty;
    }
}