/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
package at.jku.mevss.trace.gui.frame.main.tab.heapvisualization.component.paintconfigurationpane;

import at.jku.mevss.trace.gui.frame.main.tab.heapvisualization.HeapVisualizationTab;
import at.jku.mevss.trace.gui.frame.main.tab.heapvisualization.model.ClusterLevel;
import at.jku.mevss.trace.gui.utils.Consts;
import at.jku.mevss.trace.gui.utils.FXMLUtil;
import at.jku.mevss.trace.gui.utils.ImageUtil;
import javafx.fxml.FXML;
import javafx.scene.control.*;

public class PaintConfigurationPane extends TitledPane {

    @FXML
    public Spinner<Integer> clusterSizeSpinner;
    @FXML
    public ComboBox<String> unitComboBox;
    @FXML
    public ComboBox<ClusterLevel> clusterLevelComboBox;
    @FXML
    public Button autoButton;

    @FXML
    public Label zoomLabel;
    @FXML
    public Button zoomInButton;
    @FXML
    public Button zoomOutButton;
    @FXML
    public CheckBox showPointersCheckBox;
    @FXML
    public Button resetObjectsButton;

    public PaintConfigurationPane() {
        FXMLUtil.load(this, PaintConfigurationPane.class);
    }

    public void init() {
        clusterSizeSpinner.setValueFactory(new SpinnerValueFactory.IntegerSpinnerValueFactory(1, 1024, HeapVisualizationTab.DEFAULT_CLUSTER, 1));

        unitComboBox.getItems().addAll(new String[]{HeapVisualizationTab.NO_PREFIX, HeapVisualizationTab.KILO, HeapVisualizationTab.MEGA, HeapVisualizationTab.GIGA});
        unitComboBox.getSelectionModel().select(0);
        clusterLevelComboBox.getItems().addAll(ClusterLevel.values());
        clusterLevelComboBox.getSelectionModel().select(0);

        autoButton.setGraphic(ImageUtil.getIconNode(Consts.DISABLE_MAGNIFIER_ICON));
        autoButton.setTooltip(new Tooltip("Resets zoom and sets cluster size to fill the screen"));

        zoomInButton.setGraphic(ImageUtil.getIconNode(Consts.ZOOM_IN_ICON));
        zoomInButton.setTooltip(new Tooltip("Zoom in"));
        zoomOutButton.setGraphic(ImageUtil.getIconNode(Consts.ZOOM_OUT_ICON));
        zoomOutButton.setTooltip(new Tooltip("Zoom out"));

        resetObjectsButton.setTooltip(new Tooltip(HeapVisualizationTab.NO_OBJECT_GROUPS));
    }

}
