/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
/**
 *
 */
package at.jku.mevss.trace.gui.frame.main.tab.heapvisualization.model;

import java.awt.*;
import java.awt.color.ColorSpace;

/**
 * @author christina
 */
public class ColorGenerator {

    private final Color startColor;
    @SuppressWarnings("unused")
    private final float[] startValues;

    private Color currentColor;

    public ColorGenerator(Color start) {
        startColor = start;
        startValues = startColor.getColorComponents(null);
    }

    public synchronized Color getNextColor() {
        if (currentColor == null) {
            currentColor = startColor;
        } else {
            ColorSpace hsl = new HSLColorSpace();
            float[] hslvalues = hsl.fromRGB(currentColor.getColorComponents(null));
            hslvalues[0] = (hslvalues[0] + 55.0f) % 360.0f;
            //			if((int)hslvalues[0] == (int)startValues[0]){
            //				hslvalues[2] = (hslvalues[2]+4)%101.f;
            //			}
            float[] rgb = hsl.toRGB(hslvalues);
            currentColor = new Color(rgb[0], rgb[1], rgb[2]);
        }
        return currentColor;
    }
}
