/*
Copyright (c) 2014, 2015, 2016, 2017, dynatrace and/or its affiliates. All rights reserved.
This file is part of the AntTracks Tool.

This code is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 only, as
published by the Free Software Foundation.

This code is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
version 2 for more details (a copy is included in the LICENSE file that
accompanied this code).

You should have received a copy of the GNU General Public License
along with with this work.  If not, see <http://www.gnu.org/licenses/>.
*/
/**
 *
 */
package at.jku.mevss.trace.gui.frame.main.tab.heapvisualization.model;

import at.jku.mevss.anttracks.heap.symbols.AllocatedType;
import at.jku.mevss.anttracks.heap.symbols.AllocationSite;

/**
 * @author Christina Rammerstorfer
 */
public class HeapStateObjectInfo {
    public final long address;
    public final Object classifications;
    public final AllocationSite allocationSite;
    public final AllocatedType type;
    public final int size;

    public HeapStateObjectInfo(long address, Object classifications, AllocationSite allocationSite, AllocatedType type, int size) {
        super();
        this.address = address;
        this.classifications = classifications;
        this.allocationSite = allocationSite;
        this.type = type;
        this.size = size;
    }

    @Override
    public int hashCode() {
        int result = 1;
        int c = (int) (address ^ (address >>> 32));
        result = 37 * result + c;
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj instanceof HeapStateObjectInfo) {
            HeapStateObjectInfo other = (HeapStateObjectInfo) obj;
            return address == other.address;
        }
        return false;
    }

}
