package at.jku.mevss.trace.gui.frame.main.tab.lifetimevisualization.visualization;

import at.jku.mevss.anttracks.classification.nodes.GroupingNode;
import at.jku.mevss.trace.gui.frame.main.tab.lifetimevisualization.LifetimeVisualizationTab;
import at.jku.mevss.trace.gui.model.AppInfo;
import at.jku.mevss.trace.gui.utils.AntTask;
import at.jku.mevss.trace.gui.utils.PlatformUtil;

import java.util.Map;

public class LifetimeVisualizationPlottingTask extends AntTask<Boolean> {

    private final LifetimeVisualizationTab tab;
    private final AppInfo appInfo;
    private final Map<Long, GroupingNode> mapGroupings;

    public LifetimeVisualizationPlottingTask(LifetimeVisualizationTab tab, AppInfo appInfo, Map<Long, GroupingNode> mapGroupings) {
        this.tab = tab;
        this.appInfo = appInfo;
        this.mapGroupings = mapGroupings;
    }

    @Override
    protected Boolean backgroundWork() throws Exception {
        PlatformUtil.runAndWait(() -> {
            tab.updateChartData(mapGroupings);
        });
        return null;
    }

    @Override
    public boolean showOnUI() {
        return false;
    }

    @Override
    protected void suceeded() {
    }
}
