package at.jku.mevss.trace.gui.model;

import at.jku.mevss.anttracks.classification.Classifier;
import at.jku.mevss.anttracks.classification.ClassifierFactoryList;
import at.jku.mevss.anttracks.classification.FilterFactoryList;
import at.jku.mevss.anttracks.heap.IndexBasedHeap;
import at.jku.mevss.anttracks.heap.symbols.Symbols;

import java.util.function.Supplier;

public abstract class AvailableClassifierInfo {
    protected ClassifierFactoryList availableClassifier;
    protected FilterFactoryList availableFilter;

    public abstract Supplier<IndexBasedHeap> getFastHeapSupplier();

    public abstract Supplier<Symbols> getSymbolsSupplier();

    public ClassifierFactoryList getAvailableClassifier() {
        return availableClassifier;
    }

    public FilterFactoryList getAvailableFilter() {
        return availableFilter;
    }

    public Classifier<?> getClassifier(String name) {
        return getAvailableClassifier().get(name);
    }
}
