package at.jku.mevss.trace.gui.task;

import at.jku.mevss.anttracks.heap.DetailedHeap;
import at.jku.mevss.anttracks.heap.IndexBasedHeap;
import at.jku.mevss.anttracks.parser.heap.HeapTraceParser;
import at.jku.mevss.anttracks.util.TraceException;
import at.jku.mevss.trace.gui.model.AppInfo;

import java.io.IOException;
import java.util.concurrent.ExecutionException;

public abstract class FastHeapTask extends HeapTask<IndexBasedHeap> {
    public FastHeapTask(AppInfo appInfo, long time) {
        super(appInfo, time);
    }

    @Override
    protected IndexBasedHeap parse(HeapTraceParser parser) throws InterruptedException, IOException, TraceException, ExecutionException {
        DetailedHeap detailedHeap = parser.parse(cancelProperty);
        /*
        AntTask<IndexBasedHeap> convertDetailedHeapToIndexBasedHeapTask =
                new AntTask<IndexBasedHeap>() {
                    @Override
                    protected IndexBasedHeap backgroundWork() throws Exception {
                        FastHeapTask.this.updateTitle("Calculate index-based heap based on reconstructed heap state");
                        // TODO Introduce listener to show progress during fast heap generation
                        return detailedHeap.toIndexBasedHeap();
                    }

                    @Override
                    protected void suceeded() { }
                };
        return ThreadUtil.startTask(convertDetailedHeapToIndexBasedHeapTask).get();
        */
        updateMessage("Calculate index based heap for time " + (time / 1000.0) + "s (this may take some seconds, please wait)");
        return parser.parseFastHeap(cancelProperty);
    }
}