# Path to AntTracks VM
JAVA="/home/markus/LatestBuild/release/j2sdk-image/bin/java"

# Root of HeapDiffing project
HEAP_DIFFING="../../../../Examples/HeapDiffing/"

# Root of Parser project
PARSER="../../"

# Additional command line paramteres
JAVA_PARAMETER=$1

# 
if [ "$(uname)" == "Darwin" ]; then
    # Do something under Mac OS X platform
    SEP=":"
elif [ "$(expr substr $(uname -s) 1 5)" == "Linux" ]; then
    # Do something under GNU/Linux platform
    SEP=":"
elif [ "$(expr substr $(uname -s) 1 6)" == "CYGWIN" ]; then
    # Do something under Windows NT platform
    SEP=";"
fi

pushd $HEAP_DIFFING
ant Clean
ant Prepare
ant

popd
cp $HEAP_DIFFING/build/HeapDiffing.jar .

$JAVA -Xmx2G $JAVA_PARAMETER -XX:+TraceObjects -XX:TraceObjectsSymbolsFile=./symbols -XX:TraceObjectsTraceFile=./trace -cp HeapDiffing.jar example02.Main 100000

pushd $PARSER
$JAVA -cp "bin${SEP}lib/*${SEP}test/lib/*" org.junit.runner.JUnitCore at.jku.mevss.trace.parser.test.HeapDiff_Test
